% ce script donne la correction de l'interrogation de TD de MT40, A04,
% pour les diffrents groupes.

% fonctions connexes utilises : eval_horner, diff_div_dist,
%           points_poids_gauss, int_gauss, iteration_dichotomie
 
clear all;
format long e;
ntd=0;
while (ntd~=1)&(ntd~=2)
    disp('mercredi de 8  10 ; TD 1 : entrez numro 1');
    disp('mercredi de 10  12 : TD 3 : entrez numro 2');
    ntd=input('Entrez votre numro de TD : ');
end
nexo=0;
while (nexo~=1)&(nexo~=2)&(nexo~=3)
    nexo=input('Entrez le numro de l''exercice dont vous voulez la correction : ');
end


switch(nexo)
    case 1
      % Exercice 1
      disp(' ');
      disp('Exercice  1');
      disp(' ');
      alpha=[1,4];
      n=2;
      h=2/n;
      X=-1+(0:n)*h;
      Y=1./(1+alpha(ntd)*X.^2);
      % calcul des diffrences divises
      D=diff_div_dist(X,Y);
      disp('Diffrences divises ');
      disp(D),
      disp('Appuyez sur une touche pour continuer ');
      pause;
      % calcul de p_2(0.99)
      res=eval_horner(0.99,X(1:end-1),D);
      disp(' ');
      disp('Valeur de p_2(0,99)');
      disp(res);
    case 2
      % Exercice 2
      disp(' ');
      disp('Exercice  2');
      disp(' ');    
      [points,poids]=points_poids_gauss(ntd+1,4);
      disp('Valeurs des points de Gauss ');
      disp(points);
      disp('Valeurs des poids de Gauss ');
      disp(poids);
      disp('Appuyez sur une touche pour continuer ');
      pause;
      % calcul des intgrales approches
      for j=2:4
         auxi=int_gauss(j,points,poids,'cos');
         Iapp(j-1)=auxi;
         disp(['intgrale approche pour n=',num2str(j)]);
         disp(auxi);
      end
      disp('Appuyez sur une touche pour continuer ');
      pause;
      % calcul de la valeur exacte
      syms x;
      switch ntd
          case 1
             I(1)=int(cos(x)/sqrt(1-x^2),-1,1);
          case 2 
             I(2)=int(cos(x)*exp(-x^2),-inf,inf);
      end
      disp('intgrale exacte en symbolique');
      disp(I(ntd));
      disp('intgrale exacte en numrique');
      disp(double(I(ntd)));
      disp('Appuyez sur une touche pour continuer ');
      pause;
      % calcul des erreurs
      for j=2:4
         disp(['Erreur pour n=',num2str(j)]);
         disp(abs(Iapp(j-1)-double(I(ntd))));
      end
    case 3
      % Exercice 3
      disp(' ');
      disp('Exercice  3');
      disp(' ');    
      a=0;
      b=pi/2;
      switch ntd
          case 1
             chaine='cos(x)-x';
          case 2 
             chaine='cos(x)-(sin(x))^2';
      end
      fcn=inline(chaine);
      % calcul de la solution  approche 
      [n,X]=iteration_dichotomie(a,b,100,1e-1,fcn);
      disp('Premires valeurs de la mthode par dichotomie');
      disp(X);
      disp('Appuyez sur une touche pour continuer ');
      pause;
      % calcul de la solution  exacte en calcul formel  
      Sauxi=double(solve(chaine));
      ind=find((imag(Sauxi)==0)&(Sauxi<b)&(Sauxi>a));
      S=Sauxi(ind);
      disp('Solution exacte ');
      disp(S);
      disp('Appuyez sur une touche pour continuer ');
      pause;
      % affichage des erreurs commises  
      disp('Premires valeurs des erreurs de la mthode par dichotomie');
      disp(abs(X-S));
      disp('Appuyez sur une touche pour continuer ');
      pause;
      % calcul de la solution  approche pour une plus faible prcision 
      [n,X]=iteration_dichotomie(a,b,1000,1e-16,fcn);
      disp('Valeur finale du calcul par dichotomie avec epsilon lev : 1e-16');
      disp(abs(X(end)-S));
  end

